/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

var exquilla;
if (typeof(exquilla) == 'undefined')
  exquilla = {};

exquilla.mwoOverlay = (function _mwoOverlay()
{
  const Cc = Components.classes;
  const Ci = Components.interfaces;
  const Cu = Components.utils;
  const Cr = Components.results;

  let pub = {};
  if (typeof (exquilla.Utils) == "undefined")
    Object.assign(exquilla, ChromeUtils.import("resource://exquilla/modules/ewsUtils.jsm"));

  // local shorthands
  let re = exquilla.Utils.re;
  let dl = exquilla.Utils.dl;
  let log = exquilla.Utils.ewsLog;
  let safeGetJS = exquilla.Utils.safeGetJS;

  function onLoad()
  {
    log.debug("mwoOverlay onLoad()");
    if (!window.folderPane) { /* COMPAT for TB 102 */
      return;
    }

    // override server selection to allow us to probe for subfolders
    exquilla.oldFolderPane_onSelect = folderPane._onSelect;
    folderPane._onSelect = function _onSelect() {
      exquilla.oldFolderPane_onSelect();
      if (gFolder instanceof Ci.nsIMsgFolder && gFolder.isServer) {
        let server = gFolder.server;
        if (server.type == 'exquilla') {
          server.performExpand(top.msgWindow);
        }
      }
    };

    // TODO override folderPane to hide the ExQuilla account when mail is disabled

    // dbview ApplyCommandToIndices has an explicit check for IMAP folder type that
    //  is used to perform needed server calls. We have to capture any commands
    //  that might use that so we can do our own server calls.
    exquilla.commandControllerDoCommand = commandController.doCommand;
    commandController.doCommand = function _doCommand(command, ...args) {
      if (safeGetJS(gFolder, "EwsMsgFolder") && command == "cmd_markThreadAsRead") {
        log.debug("markThreadRead on an ExQuilla folder");
        // Use MarkMessagesRead, that is what the user thinks he is actually doing,
        //  and this uses a proper folder command.
        command = "cmd_markAsRead";
      }
      exquilla.commandControllerDoCommand.call(commandController, command, ...args);
    };
  }

  // publically available symbols
  pub.onLoad = onLoad;

  return pub;
})();

window.addEventListener("load", function() { exquilla.mwoOverlay.onLoad();}, false);
